// ************************************************
//  STL - list
//  SLT-LIST3.CPP
//  Exemplo de LIST de strings, com ordenao 
// ************************************************
#include <iostream>
#include <list>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;
using std::list;

bool em_ordem(const string &s1, const string &s2)
{
    
    if (s1 < s2)
        return true;
    else return false; 
}


int main()
{
   list<string> lista;   
   list<string>::iterator p;
   string *aux;
 
   // verifica se a lista est vazia
   if (lista.empty())
      cout << "Lista vazia !\n ";
   else cout << "Lista no vazia !\n";
   
   // aponta para o inicio da lista
   p = lista.begin();

   cout << "Adicionando...\n";
   // adiciona uma pessoa na lista
   aux = new string("Zuleica");
   lista.push_back(*aux);
   aux = new string("Jose");
   lista.push_back(*aux);
   aux = new string("Maria");
   lista.push_back(*aux);
   aux = new string("Abel");
   lista.push_back(*aux);
  
   if (lista.empty())
      cout << "Lista vazia !\n ";
   else cout << "Lista no vazia !\n";
   
   cout << "\n\ntamanho: " << lista.size() << endl;
   // Impresso da lista
   cout << "\n\nImpresso da lista:\n";


   lista.sort(em_ordem);
   p = lista.begin();
   for (int i=0; i<lista.size();i++)
   {
       cout << i << ":" << *p << endl;
       p++;
   }
   cout << "\n";
         
   system("PAUSE");	
   return 0;
} 

